PSTAT(8)

NAME
pstat - display system data structures

SYNOPSIS
pstat [-fknsTtv] [-d format] [-M core] [-N system] [symbols]

DESCRIPTION
pstat displays open file entry, swap space utilization, terminal state, and vnode data structure information. If core is given, the information is sought there, otherwise in the running kernel via /dev/kmem. The required namelist is taken from the running kernel unless system is specified.

The options are as follows:

-d format
    Print the values of symbols using the specified format. format is a printf(3)-style format, without the leading percent or precision specifiers, such as s, p, or llx. Symbol names are read from the remaining command line arguments. Addresses may also be specified in hex.

-f  Print the open file table with these headings:

    LOC The core location of this table entry.

    TYPE
        The type of object the file table entry points to.

    FLG Miscellaneous state variables encoded thus:

        R   open for reading
        W   open for writing
        A   open for appending
        L   exclusive or shared lock present
        I   signal pgrp when data ready
        d   deferred for next AF_UNIX garbage collection pass
        l   file descriptor slot is larval
        m   marked during AF_UNIX garbage collection pass

    CNT Number of processes that know this open file.

    MSG Number of messages outstanding for this file.

    DATA
        The location of the vnode table entry or socket structure for this file.

    OFFSET
        The file offset (see lseek(2)). This information is only visible to the user or superuser.

-k  Use 1K-byte blocks.

-M core
    Extract values associated with the name list from the specified core instead of the running kernel.

-N system
    Extract the name list from the specified system instead of the running kernel.

-n  Print devices by major/minor number rather than by name.

-s  Print information about swap space usage on all the swap areas compiled into the kernel. The first column is the device name of the partition. The next column is the total space available in the partition. The Used column indicates the total blocks used so far; the Available column indicates how much space is remaining on each partition. The Capacity reports the percentage of space used.

    If more than one partition is configured into the system, totals for all of the statistics will be reported in the final line of the report.

-T  Prints the number of used and free slots for open files, used vnodes, and swap space. It is useful for checking to see how large system tables become if the system is under heavy load.

-t  Print table for terminals with these headings:

    LINE
        Physical device name.

    RAW Number of characters in raw input queue.

    CAN Number of characters in canonicalized input queue.

    OUT Number of characters in output queue.

    HWT High water mark for output.

    LWT Low water mark for output.

    COL Calculated column position of terminal.

    STATE
        Miscellaneous state variables encoded thus:

        W   waiting for open to complete
        O   open
        C   carrier is on
        T   delay timeout in progress
        F   outq has been flushed during DMA
        B   busy doing output
        A   process is awaiting output
        X   open for exclusive use
        S   output stopped
        K   further input blocked
        Y   tty in async I/O mode
        D   next character is escaped lowercase special
        E   printing erase sequence
        L   next character is literal
        P   retyping suspended input
        N   counting tab width, ignoring output flush

    SESS
        Enclosing session.

    PGID
        Process group for which this is controlling terminal.

    DISC
        Line discipline: ‘term’ for TTYDISC (see termios(4)), ‘slip’ for SLIPDISC , ‘ppp’ for PPPDISC (see ppp(4)), ‘strip’ for STRIPDISC, and ‘nmea’ for NMEADISC (see nmea(4)).

-v  Print the active vnodes. Each group of vnodes corresponding to a particular filesystem is preceded by a two line header. The first line consists of the following:

    *** MOUNT fstype from on on fsflags

    where fstype is one of the file systems supported by the kernel; from is the partition the filesystem is mounted from; on is the directory the filesystem is mounted on; and fsflags is a list of optional flags applied to the mount (see mount(8)). The second line is a header for the individual fields, the first part of which are fixed, and the second part are filesystem type specific. The headers common to all vnodes are:

    ADDR
        Location of this vnode.

    TYP File type.

    VFLAG
        A list of letters representing vnode flags:

        R   VROOT root of its file system.
        T   VTEXT pure text prototype.
        S   VSYSTEM vnode being used by kernel.
        I   VISTTY vnode represents a tty.
        L   VXLOCK locked to change underlying type.
        W   VXWANT process is waiting for vnode.
        B   VBWAIT waiting for output to complete.
        A   VALIASED vnode has an alias.
        F   VONFREELIST vnode is on a free list.
        l   VLOCKSWORK FS supports locking discipline.
        s   VONSYNCLIST vnode is on syncer worklist.

    USE The number of references to this vnode.

    HOLD
        The number of I/O buffers held by this vnode.

    FILEID
        The vnode fileid. In the case of ffs this is the inode number.

    IFLAG
        Miscellaneous filesystem specific state variables encoded thus:

        For ffs:
            A   access time must be corrected
            C   changed time must be corrected
            U   modification time must be corrected
            R   has a rename in progress
            M   contains modifications
            m   contains lazy modifications
            S   shared lock applied
            E   exclusive lock applied

        For nfs:
            W   waiting for I/O buffer flush to complete
            P   I/O buffers being flushed
            M   locally modified data exists
            E   an earlier write failed
            X   non-cacheable lease (nqnfs)
            O   write lease (nqnfs)
            G   lease was evicted (nqnfs)
            A   special file accessed
            U   special file updated
            C   special file times changed

    SIZ/RDEV
        Number of bytes in an ordinary file, or major and minor device of special file.

ENVIRONMENT

BLOCKSIZE
    If the environment variable BLOCKSIZE is set, and the -k option is not specified, the block counts will be displayed in units of that size block.

SEE ALSO
fstat(1), netstat(1), procmap(1), ps(1), systat(1), tcpbench(1), top(1), stat(2), printf(3), fs(5), iostat(8), vmstat(8) UNIX Implementation, Ken Thompson, Bell System Technical Journal, Volume 57, Number 6, 1978, 1931–1946.

HISTORY
The pstat command appeared in 4.0BSD.

BUGS
Swap statistics are reported for all swap partitions compiled into the kernel, regardless of whether those partitions are being used.

Does not understand NFS swap servers.